// #autoload
// #name = SS Speed Hud
// #version = 1.1
// #date = February 1, 2003
// #author = Chris Lee
// #warrior = Silverspirit
// #email = uncle_crewcut@hotmail.com
// #web = http://scripts.tribalwar.com/silverspirit
// #description = Shows current and max speed. Max speed is not affected while in a vehicle.
// #category = Silverspirit's Scripts
// #status = Release

if (!isObject(ssSpeedHud))
    new ScriptObject(ssSpeedHud) {
        class = ssSpeedHud;
        Max = 0;
        Mounted = false;
    };

package ssSpeedHud {
    function ssSpeedHud::Setup(%this) {
        if (%this.Setup)
            return;
        new GuiControlProfile(ssSpeedHudProfile) {
            fontType = "Univers";
            fontSize = 15;
            fontColor = "255 255 255 255";
            fontColors[1] = "255 179 0 255";
            fontColors[2] = "255 0 0 255";
            justify = "left";
        };
        new GuiTextCtrl(ssSpeedHudCurrent) {
            profile = "ssSpeedHudProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "33 0";
            extent = "167 15";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
            text = "\c1Current: \c00";
        };
        new GuiTextCtrl(ssSpeedHudMax) {
            profile = "ssSpeedHudProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "33 0";
            extent = "167 15";
            minExtent = "8 8";
            visible = "1";
            maxLength = "255";
            text = "\c2Max: \c00";
        };
        if (isObject(HM) && isObject(HudMover)) {
            hudmover::addhud(ssSpeedHudCurrent, "SS Speed Current");
            hudmover::addhud(ssSpeedHudMax, "SS Speed Max");
        }
        PlayGui.add(ssSpeedHudCurrent);
        PlayGui.add(ssSpeedHudMax);
        addMessageCallback('MsgClientJoin', ssSpeedHudHandleJoin);
        addMessageCallback('MsgMissionStart', ssSpeedHudHandleStart);
        %this.Setup = true;
    }
    
    function ssSpeedHud::Update(%this) {
        %speed = mFormatFloat(getControlObjectspeed() * 3.6,"%.f");
        ssSpeedHudCurrent.setText("\c1Current: \c0" @ %speed);
        if (%speed > ssSpeedHud.Max && !%this.Mounted) {
            ssSpeedHudMax.setText("\c2Max: \c0" @ %speed);
            %this.Max = %speed;
        }
        %this.thread = %this.Schedule(50,Update);
    }
    
    function ssSpeedHud::Reset(%this) {
        if (!isEventPending(%this.thread))
            %this.Update();
        ssSpeedHudMax.setText("\c2Max: \c00");
        %this.Max = 0;
    }
    
    function DispatchLaunchMode() {
        parent::DispatchLaunchMode();
        if (!isObject(autoload))
            ssSpeedHud.Setup();
    }
    
    function ssSpeedHudHandleJoin(%msgType, %msgString, %clientName, %clientId) {
        if (strStr(%msgString, "Welcome to Tribes") != -1)
            ssSpeedHud.Reset();
    }
    
    function ssSpeedHudHandleStart(%msgType, %msgString) {
        ssSpeedHud.Reset();
    }
    
    function clientCmdVehicleMount() {
        parent::clientCmdVehicleMount();
        ssSpeedHud.Mounted = true;
    }

    function clientCmdVehicleDismount() {
        parent::clientCmdVehicleDismount();
        ssSpeedHud.Mounted = false;
    }
};
activatePackage(ssSpeedHud);
if (isObject(autoload))
    ssSpeedHud.Setup();
